/*********************************************************************************************
		tHgAXN[QƃXvCggĂPXs\郉Cu
		
		PUFJ[AcvCo[W
		
		Takahiro Igi (Nov 29 2003)
		
*********************************************************************************************/

#include <sys/bios.h>
#include <sys/libwwc.h>

#define ST_BASE 1
#define SP_BASE 0

#define MACRO_SJIS(c) ((c) >= 0x81 && (c) <= 0x9F || (c) >= 0xE0 && (c) <= 0xFC)

int color_text_put_string(int sx, int sy, int surfacecolor, int backcolor, int scpal, int sppal, int mir, char far c_string[]);
char *itostr(long num);

void screendraw(int screen, int x, int y, int w, int h, int mir, int pal, int charno);

void spriteinit(int spno, int fonno, int w, int h, int mir, int pr, int pal);
void spritedraw(int spno, int x, int y, int w, int h);

enum {PAL00 = 0, PAL01, PAL08 = 8};

unsigned int pal_string[]={
	0xfff, 0x844, 0x484, 0x448, 0xf88, 0x8f8, 0x88f, 0xccf, 0xfcc, 0xf00, 0x0f0, 0x00f, 0xff0, 0xf0f, 0x0ff, 0x000,
};

unsigned long bmp_clear[] = {
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
};

int gSP_total = SP_BASE;
int gST_total = ST_BASE;

/*XN[Q̂wAXvCĝw*/
int sx19[19] = {0, 12, 3, 36, 6, 60, 9, 84, 12, 108, 15, 132, 18, 156, 21, 180, 24, 204, 27};

int main(void)
{
	int i;

	wwc_set_color_mode(COLOR_MODE_16COLOR);
	display_control(DCM_SCR1 + DCM_SCR2 + DCM_SPR);
	wwc_clear_font();
	
	lcd_set_segments(0x02);

	for(i = 0; i < 16; i++){
		wwc_palette_set_color(0, i, pal_string[i]);
		wwc_palette_set_color(8, i, pal_string[i]);
	}
	
	wwc_font_set_colordata( 0,  1, bmp_clear);

	screen_fill_char(SCREEN1, 0, 0, 28, 18, 0x0000);
	screen_fill_char(SCREEN2, 0, 0, 28, 18, 0x0000);
	
	{
		int w = 1;
		
		w += color_text_put_string(16, 1, 15, 0, 0, 8, 0, "́AXN[Qł");
		w += color_text_put_string(15, 1, 15, 0, 0, 8, 0, "́AXvCggĂ܂");
	}
	{
		int w = 1;
		
		w += color_text_put_string(13, w, 15, 0, 0, 8, 0, "pbg̕ʂ̐Fg܂");
	}
	{
		int w = 1;
		
		w += color_text_put_string(12, w,  0,  1, 0, 8, 0, "0");
		w += color_text_put_string(12, w,  1,  2, 0, 8, 0, "1");
		w += color_text_put_string(12, w,  2,  3, 0, 8, 0, "2");
		w += color_text_put_string(12, w,  3,  4, 0, 8, 0, "3");
		w += color_text_put_string(12, w,  4,  5, 0, 8, 0, "4");
		w += color_text_put_string(12, w,  5,  6, 0, 8, 0, "5");
		w += color_text_put_string(12, w,  6,  7, 0, 8, 0, "6");
		w += color_text_put_string(12, w,  7,  8, 0, 8, 0, "7");
		w += color_text_put_string(12, w,  8,  9, 0, 8, 0, "8");
		w += color_text_put_string(12, w,  9, 10, 0, 8, 0, "9");
		w += color_text_put_string(12, w, 10, 11, 0, 8, 0, "A");
		w += color_text_put_string(12, w, 11, 12, 0, 8, 0, "B");
		w += color_text_put_string(12, w, 12, 13, 0, 8, 0, "C");
		w += color_text_put_string(12, w, 13, 14, 0, 8, 0, "D");
		w += color_text_put_string(12, w, 14, 15, 0, 8, 0, "E");
		w += color_text_put_string(12, w, 15,  0, 0, 8, 0, "F");
	}
	{
		int w = 1;
		
		w += color_text_put_string(10, 1, 15, 0, 0, 8, 0, "𕶎ɕϊ");
	}
	{
		int w = 1, j = 1980;
		
		w += color_text_put_string(9, w, 15, 0, 0, 8, 0, "[ƁA");
		w += color_text_put_string(9, w, 15, 0, 0, 8, 0, itostr( (long)(j) ) );
		w += color_text_put_string(9, w, 15, 0, 0, 8, 0, "~ɂȂ܂B");
	}
	{
		int w = 1;
		
		w += color_text_put_string(7, w, 15, 0, 0, 8, 0, "c]Ήł");
	}
	{
		int w = 1;
		
		w += color_text_put_string(6, 1, 15, 0, 0, 8, 0, "P");
		w += color_text_put_string(6, 3, 15, 0, 0, 8, 1, "P");
		w += color_text_put_string(6, 5, 15, 0, 0, 8, 2, "P");
		w += color_text_put_string(6, 7, 15, 0, 0, 8, 3, "P");
	}
	key_wait();
	
	return 0;
}

/***************************************************************************************************************
J[[hŕ͂\A\^[(Ăяoŉo킩悤ɂ邽)


	sx				:\镶̐擪̂wW(OPW܂)
	sy				:\镶̂xW(OPV܂)
	surfacecolor	:\pbg̐Fԍ(OPT܂)
	backcolor		:ł͂Ȃ\pbg̐Fԍ(OPT܂)
	scpal			:XN[ɕ\镶̃pbgԍ(OPT܂)
	sppal			:XvCgɕ\镶̃pbgԍ(WPT܂)
	mir				:cE]\̗LiOFʏAPF]AQFc]ARFc]j
	c_string[]		:\镶

߂l
	char_num		:\
****************************************************************************************************************/
int color_text_put_string(int sx, int sy, int surfacecolor, int backcolor, int scpal, int sppal, int mir, char far c_string[])
{
	int char_num = 0;/*\镶̐*/
	unsigned char fs[4], fb[4]; /*tHgf[^J[邽߂̃}XNrbgz*/
	
	
	/*G[(Ȃ΍폜Ă)*/
	if(sx < 0 || sx > 18){
		return 0;
	}
	if(sy < 0 || sy > 17){
		return 0;
	}
	if(surfacecolor < 0 || surfacecolor > 15){
		return 0;
	}
	if(backcolor < 0 || backcolor > 15){
		return 0;
	}
	if(scpal < 0 || scpal > 15){
		return 0;
	}
	if(sppal < 8 || sppal > 15){
		return 0;
	}
	if(mir < 0 || mir > 3){
		return 0;
	}
	
	
	{/*tHgf[^J[邽߂̃}XNrbg*/
		int a = 0;
		
		for(a = 0; a < 4; a += 1){
			fs[a] = ( ( (surfacecolor >> a) & 0x01) != 0) ? 0xff: 0x00;
			fb[a] = ( ( (backcolor >> a)    & 0x01) != 0) ? 0xff: 0x00;
		}
	}
	{
		int c = 0, c_length = 0;
		unsigned char font_data[8]; /*ĂtHgf[^(mN)z */
		unsigned char font_data90[8];/*font_data[8]90x]rbgz*/
		unsigned char colordata[32];/*J[tHgf[^(16FJ[)z */
		
		{/*̒strlen()g킸߂*/
			int j = 0;
			
			while(c_string[j] != '\0'){ j += 1;}
			c_length = j;
		}
		
		while(c < c_length){
			{/*̃R[hԍ擾*/
				unsigned char bytecode = (unsigned char)(c_string[c]);
				unsigned int sjis_code = 0; /*1̃R[hԍ*/
				
				if( bytecode >= 0x81 && ( bytecode <= 0x9f || (bytecode >= 0xe0 && bytecode <= 0xfc) ) ){
					sjis_code  = ((unsigned int)(bytecode) << 8);
					sjis_code += (unsigned int)((unsigned char)(c_string[c + 1])) ;
					c += 2;
				}else{
					sjis_code  = (unsigned int)(bytecode);
					c += 1;
				}
				/*tHgf[^擾*/
				text_get_fontdata(sjis_code, font_data);
			}
			{/*font_data[]90x]Afont_data90[]ɓ*/
				int i = 0, b = 0;
				
				for(i = 0; i < 8; i++){
					font_data90[i] = 0;
				}
				
				for(i = 0; i < 8; i++){
					for(b = 0; b < 8; b++){
						int bit = (font_data[i] >> b) & 0x1;
						
						font_data90[7 - b] += bit << i;
					}
				}
			}
			{/*tHgf[^16FJ[ɕϊ*/
				int i = 0, j = 0, k = 0;
				
				for(i = 0, j = 0; i < 8; i += 1, j += 4){
					for(k = 0; k < 4; k += 1){
						colordata[j + k] = 0;
						colordata[j + k] = (fs[k] & font_data90[i]) | (fb[k] & ~font_data90[i]);
					}
				}
			}
			/*LN^f[^`*/
			wwc_font_set_colordata(gST_total + char_num, 1, colordata);
			
			char_num += 1;
			if(sy + char_num > 17){
				break;
			}
		}
		
		{
			if( (sx % 2) == 1){
				/*XvCgŕ\*/
				spriteinit(gSP_total, gST_total, 1, char_num, mir, 1, sppal);
				spritedraw(gSP_total, sx19[sx], (sy << 3), 1, char_num);
				gSP_total += char_num;
				sprite_set_range(0, gSP_total);
			}else{
				/*XN[ɕ`*/
				screendraw(SCREEN2, sx19[sx], sy, 1, char_num, mir, scpal, gST_total);
			}
		}
		gST_total += char_num;
	}
	return (char_num);
}


/********************************
𕶎ɕϊ֐


	num		:ɂ

߂l
	i2str[]	:ϊ
********************************/
char *itostr(long num)
{
	int a = 0, z = 0;
	int i = 0, length = 0;
	char ls[10];
	static char i2str[12];
	
	/*num}CiXAz̐擪'-'Anum𐳂̐ɂ*/
	if(num < 0){
		i2str[z++] = '-';
		num = -num;
	}
	
	/*̈ʂAnum𕶎ɕϊ*/
	do{
		ls[a++] = (char)( (num % 10) + '0');
	}while( (num /= 10) > 0);
	
	/*̈ʂ擪ɂls[]Atɂi2str[]ɓ*/
	for(i = 0, length = a; i < length; i++){
		i2str[z++] = ls[--a];
	}
	i2str[z] = '\0';
	
	return i2str;
}


/**********************************************************************************
c]ΉXN[`֐


	screen	:`悷XN[iSCREEN1 or SCREEN2j
	x		:\镶̐擪̂wW
	y		:\镶̐擪̂xW
	w		:\̈̕
	h		:\̈̍
	mir		:cE]\̗LiOFʏAPF]AQFc]ARFc]j
	pal		:\镶̃pbgԍ(OPT܂)
	charno	:\LN^ԍ̐擪̒l

߂l		:Ȃ
**********************************************************************************/
void screendraw(int screen, int x, int y, int w, int h, int mir, int pal, int charno)
{
	/*c]Ȃi낤j̏l炩ߓĂ*/
	int wvbase = 0, wvid = 1, hwbase = 0, hwid = w;
	unsigned int attr = (mir << 14) + (pal << 9) + charno;/*pbglLN^ԍ̏l*/
	
	
	if(mir & 0x01){ wvbase =  w - 1;      wvid = -1;}/*]ɑΉ鉡̏lAĒ`*/
	if(mir & 0x02){ hwbase = (h - 1) * w; hwid = -w;}/*c]ɑΉc̏lAĒ`*/
	
	{/*XN[ɕ`*/
		int wi = 0, wv = 0, hi = 0, hw = 0;
		
		for(hi = 0, hw = hwbase; hi < h; hi++, hw += hwid){
			for(wi = 0, wv = wvbase + hw; wi < w; wi++, wv += wvid){
				screen_fill_char(screen, x + wi, y + hi, 1, 1, (attr + (unsigned int)(wv) ) );
			}
		}
	}
}


/**********************************************************************************
XvCg`֐ic]AXN[DxΉj


	spno	:\XvCgԍ̐擪̒l
	fonno	:\LN^ԍ̐擪̒l
	w		:\̈̕
	h		:\̈̍
	mir		:cE]\̗LiOFʏAPF]AQFc]ARFc]j
	pr		:XN[Qɑ΂DxiOFႢAPFj
	pal		:\镶̃pbgԍ(WPT܂)

߂l		:Ȃ
**********************************************************************************/
void spriteinit(int spno, int fonno, int w, int h, int mir, int pr, int pal)
{
	/*c]Ȃi낤j̏l炩ߓĂ*/
	int wvbase = 0, wvid = 1, hwbase = 0, hwid = w;
	unsigned int attr = (mir << 14) + (pr << 13) + ( (pal - 8) << 9) + fonno;/*pbglLN^ԍ̏l*/
	
	
	if(mir & 0x01){ wvbase =  w - 1;      wvid = -1;}/*]ɑΉ鉡̏lAĒ`*/
	if(mir & 0x02){ hwbase = (h - 1) * w; hwid = -w;}/*c]ɑΉc̏lAĒ`*/
	
	{/*XN[ɕ`*/
		int wi = 0, wv = 0, hi = 0, hw = 0;
		
		for(hi = 0, hw = hwbase; hi < h; hi++, hw += hwid){
			for(wi = 0, wv = wvbase + hw; wi < w; wi++, wv += wvid){
				sprite_set_char(spno++, (attr + (unsigned int)(wv) ) );
			}
		}
	}
}


/********************************************
XvCg\֐


	spno	:\XvCgԍ̐擪̒l
	x		:\̈̍̂wW
	y		:\̈̍̂xW
	w		:\̈̕
	h		:\̈̍

߂l		:Ȃ
********************************************/
void spritedraw(int spno, int x, int y, int w, int h)
{
	int dx, dy;
	int dxm = w * 8;
	int dym = h * 8;

	for(dy = 0; dy < dym; dy += 8){
		for(dx = 0; dx < dxm; dx += 8){
			sprite_set_location(spno++, x + dx, y + dy);
		}
	}
}
